/**
 * Created by upliu <i@upliu.net> https://upliu.net/ on 08/01/2017.
 */

var $editor = $('#editor')
    , $field = $('.form-group.field-editor')
    , dataKeyPrefix = 'UpliuDraft_'
    , saveTimer

setTimeout(showLoadDraftTip, 500)

$(document).on('click', '.UpliuDraft-load', function () {
    $('.upliu_draft_tip').remove()
    loadDraft()
    startAutoSave()
}).on('click', '.UpliuDraft-delete', function () {
    $('.upliu_draft_tip').remove()
    window.localStorage.removeItem(getDataKey())
    startAutoSave()
}).on('beforeSubmit', function () {
    window.localStorage.removeItem(getDataKey())
})

function startAutoSave() {
    saveTimer = setInterval(saveDraft, 3000)
}

function saveDraft() {
    var data = {
        editor_name: null,
        htmlcode: null,
        t: Date.now()
    }
    if ($editor.data('wbb')) {
        data.editor_name = 'wbb'
        data.htmlcode = $editor.htmlcode()
    } else {
        console && console.log('不支持的编辑器')
        return
    }

    localStorage.setItem(getDataKey(), JSON.stringify(data))
}

function loadDraft() {
    data = localStorage.getItem(getDataKey())
    data = JSON.parse(data)
    $editor.htmlcode(data.htmlcode)
}

function isDraftValid(data) {
    return ($editor.data('wbb') && data.editor_name == 'wbb')
    || (!$editor.data('wbb') && data.editor_name != 'wbb')
}

function showLoadDraftTip() {
    if (data = localStorage.getItem(getDataKey())) {
        data = JSON.parse(data)
        if (isDraftValid(data)) {
            $field.prepend('<p class="upliu_draft_tip">是否加载 ' + formatDate(data.t) + ' 自动保存的草稿 <small class="UpliuDraft-delete">删除</small> <small class="UpliuDraft-load">加载</small></p>')
        } else {
            startAutoSave()
        }
    } else {
        startAutoSave()
    }
}

function getDataKey() {
    var key
    if (window.UpliuDraft_comment_id !== undefined) {
        key = dataKeyPrefix + 'c_' + UpliuDraft_comment_id
    } else {
        key = dataKeyPrefix + 't_' + UpliuDraft_topic_id
    }
    return key
}

function formatDate(t) {
    t = new Date(t)
    return [
        [t.getFullYear(), t.getMonth()+1, t.getDate()].join('-'),
        [t.getHours(), t.getMinutes(), t.getSeconds()].join(':')
    ].join(' ')
}